#/usr/bin/perl 

BEGIN {
    push @INC,"./lib";
    push @INC,"../lib";
}

use IO::Socket;  #네트워크 모듈 사용하기 
use MashaalaModule; #모듈 실행 임포트 
#설정파일에서 읽어와서 저장되는 부분 
#지금은 각종 아이피 및 포트 정보  
my $send_address ="";
my $send_port="";
my $local_address="";
my $local_port="";


#설정정보 아이피 포트 가져온다  
config();

#서버로부터 입력을 받아들인다 
my $main_sock = new IO::Socket::INET(#소켓생성 
    #LocalHost=>'localhost',#주소
    #LocalHost=>get_myip('vboxnet0'),#주소
    LocalHost=>get_myip('eth0'),#주소
    LocalPort=>$local_port,#포트 
    #LocalPort=>'8888',#포트 
    Proto=>'tcp',#프로토콜
    Listen=>1,#모드 
);
die "::Could not connect \n" unless $main_sock;#소켓이 제대로 열렸는지 체크 


#클라이언트에서 메시지를 기다린다 
#메시지가 들어오면 accept()로 객체를 생성해 $new_sock에 넣는다 
$pid = fork(); #새로운 프로세스를 생성한다 
die "Cant not fork : $! " unless defined($pid);#프로세스 체크 
#서버는 늘 떠있어야하므로 자식프로세스로서 항상 떠있도록 한다 
if($pid == 0){ #pid가 0이면 자식 프로세스이다 이 {}안의 것은 자식프로세스에서만 실행되는 것이다 
    while(my $new_sock = $main_sock->accept())
    {
        my $pid = fork();#새로운 프로세스 생성 
        die "Can not fork : $! " unless defined($pid); #프로세스가 제대로 생성 되었는지 
        if($pid == 0){ #pid가 0이면 자식 프로세스이므로 자식 프로세스일때 아래를 실행
            my $string  = "";
            while(<$new_sock>){ #소켓에서 메시지를 다 가져올때까지 루프 
                print "\n<< " ,  $_  , "\n"; #따로 명시 하지 않았으므로 $_들어가 있다 이것을 화면에 출력
                $string = $string . $_;
            }
            @_ = split /\*/ ,$string;
            if($_[0] eq "PLUGIN_LIST"){
                open(DA, ">module_list");
                print DA  $_[1];
                close(DA);
            }

            if($_[0] eq "REACTION"){
                reaction($_[1]);
            }

            exit(0);#현재 자식 프로세스를 종료 
        }
    }
    close($main_sock);#소켓 닫기 
}






#루프를 5초마다 돌리면서 각각 모듈을 실행시킨다 
while(1)
{
    moduleRun();
    sleep(5);
}


#여기에서 서버로 메시지를 보낸다 
sub Send_sock
{

    #소켓 만들기 
    my $sock = new IO::Socket::INET(
        PeerAddr => $send_address, #받는 서버 아이피 
        PeerPort => $send_port, #받는 서버 포트 
        Proto => 'tcp',#통신방지
    );

    die "send not connect \n" unless $sock; #소켓이 제대로 생성됫는지 체크 
    print $sock $_[0]; #$sock소켓으로 받아온 메시지 전송 
    #print $_[0]; #테스트용 으로 찍어준거 
    close($sock); #소켓을 닫아준다 
}


#모듈을 실행시킨다 
sub moduleRun
{
    #모듈 생성 java의 new와 같음 
    my $mc = MashaalaModule->new();
    #메시지의 첫머리에 IP를 집어 넣는다 
    #IP=192.168.5.5 같은 형식이 된다 
    my $string = "IP=" . get_myip('eth0') . "\n";
    #모듈을 실행시켜서 그에 합당하는 메시지를 가져 온다 
    #아래와 같은 형식의 메시지를 받아 온다 
    #=-=
    #PLUGINSTART=:-:CPUINFO:-:
    #total=56%
    #free=57%
    #PLUGINEND


    $string .= $mc->runModule();
    #아래와 같은 메시지가 만들어 진다 
    #IP=192.168.5.5 같은 형식이 된다 
    #=-=
    #PLUGINSTART=:-:CPUINFO:-:
    #total=56%
    #free=57%
    #PLUGINEND
    #=-=
    #PLUGINSTART=:-:MEMINFO:-:
    #total=56%
    #free=57%
    #PLUGINEND

    #Send_sock함수를 통하여 서버로 메시지를 전송한다 
    #   print "xxxxxxxxxxxxxxxxxxxxx" , $string, "yyyyyyyyyyyyyyyyyyyy\n";
    Send_sock($string);
}

#모듈을 실행시킨다 
sub reaction 
{
    my $pl = shift;
    #모듈 생성 java의 new와 같음 
    my $mc = MashaalaModule->new();
    $mc->reaction($pl);
}

#설정파일로부터 읽어 들이기
sub config{
    #config파일이 있는지체크 
    if(!open CONFIG,"config")
    {
        die "file not find!!!";
    }
    #config파일에서 텍스트 읽어 들여 처리 
    while(<CONFIG>)
    {
        #널값처리 
        chomp;
        #각각 =을 기준으로 나누어서 그에 맞는 값을 가져온다 
        $send_address = (split /=/ , $_)[1] if(/send_address/); 
        $send_port = (split /=/ , $_)[1] if(/send_port/);
        $local_address = (split /=/ , $_)[1] if(/local_address/);
        $local_port= (split /=/ , $_)[1] if(/local_port/);
    }
}


#로컬의 ip를 받아 온다 
sub get_myip(){
    my $interface=$_[0];
    print $interface. "\n";
    #$interface="eth0";
    $ifconfig="/sbin/ifconfig";
    @lines=qx|$ifconfig $interface| or die("Can't get info from ifconfig: ".$!);
    foreach(@lines){
        if(/inet addr:([\d.]+)/){
            return $1;
        }
    }
    return ;
}

