package Monitoring;
# 이 모듈은 모니터링에 관련해서 DB처리와 얼랏처리 그리고 리액션 처리를 해주는 부분입니다 
#모듈을 가져오기 위해서 Path의 지정 
BEGIN{
    push @INC,"./lib";
    push @INC,"../lib";
}
use DBI;
use DBD::mysql;
use Split;


#생성자 
sub new{
    my ($class) = shift;
    my $self = {
        server_ip=>shift,
        mod_name=>shift,
        mysql_user=>,
        mysql_pass=>,
    };

    #설정파일로부터 mysql정보를 가져온다 
    my $config = Split->new('config');
    $config->init_file();
    $self->{mysql_user} = $config->get_pram('mysql_user');
    $self->{mysql_pass} = $config->get_pram('mysql_pass');
    bless $self, $class ;
    return $self;
}


#db에 모듈 정보를 입력한다 
sub mon_insert{
    my $self=shift; #자기 자신 인스턴스의 레퍼런스를 가져온다 
    my $total=shift;
    my $now_usage=shift;
    my $dsn = "dbi:mysql:ma:localhost:3306";
    # PERL DBI CONNECT 
    my $connect = DBI->connect($dsn,$self->{mysql_user},$self->{mysql_pass});
    # PREPARE THE QUERY 
    my $query = "INSERT INTO resource_mon(idx,server_ip,mod_name,total,now_usage) VALUES(DEFAULT,'" . $self->{server_ip} . "','" . $self->{mod_name} . "'," . $total . "," . $now_usage . ")";
    my $query_handle = $connect->prepare($query);
    # EXECUTE THE QUERY 
    $query_handle->execute();
}

#일반 value alert일경우에 대한 alert의 처리입니다 
sub value_alert{
    my $self=shift;
    my $value = shift;
    my $msg = shift;
    my $reaction;
    my $warning;
    my $alert_value;
    my $dsn = "dbi:mysql:ma:localhost:3306";
    my $connect = DBI->connect($dsn,$self->{mysql_user},$self->{mysql_pass});
    my $query = "SELECT value,alert,reaction,warning FROM server_mod where server_name like '" . $self->{server_ip} . "' and mod_name like '" . $self->{mod_name} . "'";
    print $query . "\n";
    my $query_handle = $connect->prepare($query);
    $query_handle->execute();
    $query_handle->bind_columns(\$alert_value ,\$alert,\$reaction, \$warning);
    $query_handle->fetch();
    if($value > $alert_value && $alert eq 'on'){
        $query = "INSERT INTO alert_log VALUES(DEFAULT,'" . $self->{mod_name} . "','" . $msg  . "','" . $self->{server_ip} . "','" . $warning . "',default)";
        print $query . "\n";
        $query_handle = $connect->prepare($query);
        $query_handle->execute();
        #리액션이 y가 되었을경우에 리액션을 실행하기 위해 리턴한다 
        if($reaction eq 'y'){
            return "reaction";
        }
    }
}

#일반 얼랏들을 사용시에 
sub alert{
    my $self=shift;
    my $msg = shift;
    my $warning;
    my $reaction;
    my $alert;
    #db에서 현재의 모듈상태를 읽어온다 
    my $dsn = "dbi:mysql:ma:localhost:3306";
    my $connect = DBI->connect($dsn,$self->{mysql_user},$self->{mysql_pass});
    my $query = "SELECT value,alert,reaction,warning FROM server_mod where server_name like '" . $self->{server_ip} . "' and mod_name like '" . $self->{mod_name} . "'";
    my $query_handle = $connect->prepare($query);
    $query_handle->execute();
    $query_handle->bind_columns(\$alert_value,\$alert ,\$reaction,\$warning);
    $query_handle->fetch();

    #alert가 y가 되었을 경우에만 로그에 남기도록 한다 
    if($alert ne 'n'){
        $query = "INSERT INTO alert_log VALUES(DEFAULT,'" . $self->{mod_name} . "','" . $msg  . "','" . $self->{server_ip} . "','" . $warning . "',default)";
        $query_handle = $connect->prepare($query);
        $query_handle->execute();
        #리액션이 y가 되었을경우에 리액션을 실행하기 위해 리턴한다 
        if($reaction eq 'y'){
            return "reaction";
        }
    }
}
1;
