package Monitoring;
# 이 모듈은 모니터링에 관련해서 DB처리와 얼랏처리 그리고 리액션 처리를 해주는 부분입니다 
#모듈을 가져오기 위해서 Path의 지정 
BEGIN{
    push @INC,"./lib";
    push @INC,"../lib";
}
use DBI;
use DBD::mysql;
use Split;
use IO::Socket;#네트워크 모듈 사용하기 java의 import C의 include 
use warnings "all";
no warnings "all";

#생성자 
sub new{
    my ($class) = shift;
    my $self = {
        server_ip=>shift,
        mod_name=>shift,
        mysql_user=>,
        mysql_pass=>,
        send_port=>
    };

    #설정파일로부터 mysql정보를 가져온다 
    my $config = Split->new('config');
    $config->init_file();
    $self->{mysql_user} = $config->get_pram('mysql_user');
    $self->{mysql_pass} = $config->get_pram('mysql_pass');
    $self->{send_port} = $config->get_pram('send_port');

    print "===========================\n";
    print $self->{server_ip} . "\n";
    print $self->{send_port} . "\n";
    print "===========================\n";

    bless $self, $class ;
    return $self;
}


#db에 모듈 정보를 입력한다 
sub mon_insert{
    my $self=shift; #자기 자신 인스턴스의 레퍼런스를 가져온다 
    my $total=shift;
    my $now_usage=shift;
    my $dsn = "dbi:mysql:ma:localhost:3306";
    # PERL DBI CONNECT 
    my $connect = DBI->connect($dsn,$self->{mysql_user},$self->{mysql_pass});
    # PREPARE THE QUERY 
    my $query = "INSERT INTO resource_mon(idx,server_ip,mod_name,total,now_usage) VALUES(DEFAULT,'" . $self->{server_ip} . "','" . $self->{mod_name} . "'," . $total . "," . $now_usage . ")";
    my $query_handle = $connect->prepare($query);
    # EXECUTE THE QUERY 
    $query_handle->execute();
}

#일반 value alert일경우에 대한 alert의 처리입니다 
sub value_alert{
    my $self=shift;
    my $value = shift;
    my $msg = shift;
    my $reaction;
    my $warning;
    my $alert_value;
    my $dsn = "dbi:mysql:ma:localhost:3306";
    my $connect = DBI->connect($dsn,$self->{mysql_user},$self->{mysql_pass});
    my $query = "SELECT value,alert,reaction,warning FROM server_mod where server_name like '" . $self->{server_ip} . "' and mod_name like '" . $self->{mod_name} . "'";
    my $query_handle = $connect->prepare($query);
    $query_handle->execute();
    $query_handle->bind_columns(\$alert_value ,\$alert,\$reaction, \$warning);
    $query_handle->fetch();
    if($alert_value ne '' && $value > $alert_value && $alert eq 'on' ){
        $query = "INSERT INTO alert_log VALUES(DEFAULT,'" . $self->{mod_name} . "','" . $msg  . "','" . $self->{server_ip} . "','" . $warning . "',default)";
        $query_handle = $connect->prepare($query);
        $query_handle->execute();
        #리액션이 y가 되었을경우에 리액션을 실행하기 위해 리턴한다 
        if($reaction eq 'on'){
            print "value reaction stat";
            reaction($self);
        }
    }
}

#일반 얼랏들을 사용시에 
sub alert{
    my $self=shift;
    my $msg = shift;
    my $warning;
    my $reaction;
    my $alert;
    #db에서 현재의 모듈상태를 읽어온다 
    my $dsn = "dbi:mysql:ma:localhost:3306";
    my $connect = DBI->connect($dsn,$self->{mysql_user},$self->{mysql_pass});
    my $query = "SELECT value,alert,reaction,warning FROM server_mod where server_name like '" . $self->{server_ip} . "' and mod_name like '" . $self->{mod_name} . "'";
    my $query_handle = $connect->prepare($query);
    $query_handle->execute();
    $query_handle->bind_columns(\$alert_value,\$alert ,\$reaction,\$warning);
    $query_handle->fetch();

    #alert가 y가 되었을 경우에만 로그에 남기도록 한다 
    if($alert eq 'on'){
        $query = "INSERT INTO alert_log VALUES(DEFAULT,'" . $self->{mod_name} . "','" . $msg  . "','" . $self->{server_ip} . "','" . $warning . "',default)";
        $query_handle = $connect->prepare($query);
        $query_handle->execute();
        #리액션이 y가 되었을경우에 리액션을 실행하기 위해 리턴한다 
        if($reaction eq 'on'){
            print "reaction stat";
            reaction($self);
        }
    }
}


#db에 모듈 정보를 입력한다 
sub reaction{
    my $self=shift; #자기 자신 인스턴스의 레퍼런스를 가져온다 
    my $sock = new IO::Socket::INET(
        PeerAddr => $self->{server_ip}, #받는 서버 아이피 
        PeerPort => $self->{send_port}, #받는 서버 포트 
        Proto => 'tcp',#통신방지
    );
    print $self->{server_ip} . "::\n";
    print $self->{send_port} . "::\n";
    die "send not connect \n" unless $sock; #소켓이 제대로 생성됫는지 체크 
    #에이전트에 리엑션이 있음을 알려준다 
    my $msg = "REACTION*" . $self->{mod_name};
    print $sock $msg ; #$sock소켓으로 받아온 메시지 전송 
    close($sock); #소켓을 닫아준다 
}


1;
