package PluginSetup;
push @INC, `pwd`."lib";
use DBI;
use DBD::mysql;
use Net::SCP::Expect;
use Net::SSH::Expect;
use File::Copy;

#생성자 
sub new{
    my ($class) = shift;
    my $self = {
        localpath=>shift, #나의 계정의 플러그인이 있는 위치 
        localplug=>shift, #플러그인명 
        remotepath=>shift, #원격에 설치될 곳 
        mysql_user=>,#mysql user id
        mysql_pass=>, #mysql user password
    };
    #설정파일로부터 mysql정보를 가져온다 
    my $config = Split->new('config');
    $config->init_file();
    $self->{mysql_user} = $config->get_pram('mysql_user');
    $self->{mysql_pass} = $config->get_pram('mysql_pass');
 
    bless $self, $class ;
    return $self;
}

#플러그인을 배포한다 
sub copyfile {
    my $self = shift;
    #로컬 파일의 카피 
    copy($self->{localpath},$self->{localplug});
    my $dsn = "dbi:mysql:ma:localhost:3306";
    my $connect = DBI->connect($dsn,$self->{mysql_user},$self->{mysql_pass});
    my $query = "SELECT server_ip,server_userid,server_userpw FROM servers";
    my ($ip,$user,$pass);
    my $query_handle = $connect->prepare($query);
    $query_handle->execute();
    $query_handle->bind_columns(\$ip,\$user,\$pass);
    #서버로 등록되있는 것의 아이피를 돌면서 복사한다 
    while($query_handle->fetch()){
        print $ip , $user, $pass , "\n";
        my $scpe = Net::SCP::Expect->new(
            user=>$user,
            password=>$pass
            ,timeout=>120
        );
        $scpe->scp($self->{localpath} ,$ip . ':~');

        my $ssh = Net::SSH::Expect->new (
            host => $ip, 
            password=> $pass, 
            user => $user, 
            raw_pty => 1,
            timeout=>30,
        );
        my $login_output = $ssh->login();
        my $filename = (split /\//,$self->{localpath})[-1];
        my $string =  "echo " . $pass ."| sudo -S mv ". $filename . " " . $self->{remotepath} ."/agent/Plugin";
        $ssh->exec($string);
    }
}


#플러그인 삭제 
sub delfile {
    my $self = shift;
    my $dsn = "dbi:mysql:ma:localhost:3306";
    my $connect = DBI->connect($dsn,$self->{mysql_user},$self->{mysql_pass});
    my $query = "SELECT server_ip,server_userid,server_userpw FROM servers";
    my ($ip,$user,$pass);
    my $query_handle = $connect->prepare($query);
    $query_handle->execute();
    $query_handle->bind_columns(\$ip,\$user,\$pass);
    while($query_handle->fetch()){
        print $ip , $user, $pass , "\n";
        my $ssh = Net::SSH::Expect->new (
            host => $ip, 
            password=> $pass, 
            user => $user, 
            raw_pty => 1,
            timeout=>30,
        );
        my $login_output = $ssh->login();
        my $filename = (split /\//,$self->{localpath})[-1];
        my $string =  "echo " . $pass ."| sudo -S rm " . $self->{remotepath} ."/agent/Plugin/" . $filename;
        print $string . "\n";
        $ssh->exec($string);
    }
}
1;
