#!/usr/bin/perl -w

BEGIN {
    push @INC,"./lib";
    push @INC,"../lib";
}
use DBI;
use DBD::mysql;
use IO::Socket;#네트워크 모듈 사용하기 java의 import C의 include 
use MashaalaModule; #마샬라의 모듈을 간리한다 
use Split;#설정파일을 처리한다 
use AgentSetup;#에이전트를 가진다 
use PluginSetup;#플러그인 관련 
use File::Copy;
use warnings "all";
no warnings "all";

#설정파일에서 읽어와서 저장되는 부분 

#변수의 초기화 
my $send_address ="";
my $send_port="";
my $local_address="";
my $local_port="";
my $path ="";
my $mysql_user="";
my $mysql_pass="";

#설정파일 불러오기 


#config파일에서 설정정보를 얻어온다 
my $config = Split->new('config');
$config->init_file();
$send_address = $config->get_pram('send_address');
$send_port = $config->get_pram('send_port');
$local_address = $config->get_pram('local_address');
$local_port = $config->get_pram('local_port');
$local_port = $config->get_pram('local_port');
$path = $config->get_pram('path');
$mysql_user= $config->get_pram('mysql_user');
$mysql_pass= $config->get_pram('mysql_pass');



Listen_sock();
#소켓을 읽어들이는 부분이다 
sub Listen_sock{

    #소켓생성하기 
    my $main_sock = new IO::Socket::INET(#소켓생성 
        LocalHost=>$local_address  ,#주소
        LocalPort=>$local_port ,#포트 
        Proto=>'tcp',#프로토콜
        Listen=>1,#모드 
    );

    die "Listen sock Could not connect \n" unless $main_sock;#소켓이 제대로 열렸는지 체크 
    #클라이언트에서 메시지를 기다린다 
    #메시지가 들어오면 accept()로 객체를 생성해 $new_sock에 넣는다 
    while(my $new_sock = $main_sock->accept())
    {
        my $pid = fork();#새로운 프로세스 생성 
        die "Can not fork : $! " unless defined($pid); #프로세스가 제대로 생성 되었>는지 
        my $msg = "";
        my $host = "";
        if($pid == 0){ #pid가 0이면 자식 프로세스이므로 자식 프로세스일때 아래를 실>행
            while(<$new_sock>){ #소켓에서 메시지를 다 가져올때까지 루프 
                #print $_; #따로 명시 하지 않았으므로 $_들어가 있다 이것을 화면에 출>력
                #my $pid = fork();
                $msg .= $_;
            }   



            #php에서 들어오는 내용들을 처리한다 
            if($msg =~ m/php.*/){
                $msg=~ s/^php//;
                php_msg($msg);
            }else{
                for (split /\n/,$msg){
                    if(/IP/){
                        @_=split /=/ , $_;
                        $host = $_[1]
                    }
                }


                print "from agent : $msg  \n";
                moduleRun($host,$msg);
            }
            #chart();
            exit(0);#현재 자식 프로세스를 종료 
        }   
    }
    close($main_sock);#소켓 닫기
}


#php(UI) 로부터 들어온 메시지를 처리한다 
sub php_msg{
    # * php로부터 들어오는 메시지 
    # 메시지타입:데이터1:데이터2:데이터3
    # * 예제 SERVER_ADD 타입의 경우 
    # SERVER_ADD:at-now.kr:nan1004au:xptmxm1234:/home/namsa/agent.tar.gz:~"

    my ($string) = @_; #php로부터받아온 메시지가 담긴다 
    print "from php : $string\n" ;
    @_=split /:/ , $string;
    $type = $_[0];
    if($type eq "SERVER_ADD"){
        my $agent = AgentSetup->new(
            ip=>$_[1],
            username=>$_[2],
            password=>$_[3],
            filepath=>$_[4],
            remotepath=>$_[5]
        );
        $agent->copyfile();
        $agent->script();
    }elsif($type eq "SERVER_DEL"){
        my $agent = AgentSetup->new(
            ip=>$_[1],
            username=>$_[2],
            password=>$_[3],
            filepath=>$_[4],
            remotepath=>$_[5]
        );

        $agent->del_script();
    }elsif($type eq "PLUGIN_ADD"){#플러그인 추가 
        print "---------------------\n";
        my $file =$_[1];
        copy($file, "Plugin") or die "File cannot be copied.";
        #에이전트들에게 플러그인을 배포한다 
        my $pl = PluginSetup->new(
            "$file",
            $path . "/Plugin",
            "/opt",
        );
        $pl->copyfile();
        print "--------------------\n";
    }elsif($type eq "PLUGIN_DEL"){#플러그인 삭제 
        my $file =$_[1];
        my $pl = PluginSetup->new(
            "$file",
            $path . "/Plugin",
            "/opt",
        );
        $pl->delfile();
        `rm -rf $path/Plugin/$file`;
    }elsif($type eq "PLUGIN_LIST"){#플러그인 추가 
        my $ip =$_[1];
        my $dsn = "dbi:mysql:ma:localhost:3306";
        my $connect = DBI->connect($dsn,$mysql_user,$mysql_pass);
        #my $query = "SELECT mod_name FROM server_mod where server_ip like '$ip'";
        my $query = "SELECT mod_name FROM server_mod";
        my ($mod_name);
        my $query_handle = $connect->prepare($query);
        my $pl_msg="PLUGIN_LIST*";
        $query_handle->execute();
        $query_handle->bind_columns(\$mod_name);
        while($query_handle->fetch()){
            $pl_msg = $pl_msg . $mod_name . "\n";
        }
        agent_send($ip,$pl_msg);
    }
}

#에이전트로 메시지를 쏜다 
sub agent_send{
    #소켓 만들기 
    my ($host,$p_msg) = @_;
    #print "host : $host ,p_msg $p_msg \n"; 
    #print "$send_port\n";
    my $sock = new IO::Socket::INET(
        PeerAddr => $host, #받는 서버 아이피 
        PeerPort => $send_port, #받는 서버 포트 
        Proto => 'tcp',#통신방지
    );
    die "::send not connect \n" unless $sock; #소켓이 제대로 생성됫는지 체크 
    print $sock $p_msg; #$sock소켓으로 받아온 메시지 전송 
    #print $p_msg; #테스트용 으로 찍어준거 
    close($sock); #소켓을 닫아준다 
}

#클라이언트로 가져온 메시지를 모듈에 맞추어 연결해 주기 
sub moduleRun{
    my $host = $_[0];#받아온 메시지의 클라이언트 아이피 
    my $arg = $_[1]; #메시지
    #print $arg;
    my @st = split /=-=\n/ , $arg;
    #print "\n================\n" , $_ , "\n===============\n" for(@st);
    my $mc = MashaalaModule->new();
    $mc->runModule($host,@st);
}
